/*  ----------------------------------------------------------------------

    Copyright (C) 2001  Tom Vandenhove  (tom.vandenhove@ubizen.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    ---------------------------------------------------------------------- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <pthread.h>
#include <sys/stat.h>
#include <unistd.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "nomadJB_data.h"
#include "id3file.h"

GtkWidget *fileselection1;
extern GtkWidget *app2;
extern int debug;
extern struct songlist *songs_root;
extern struct genre *genres_root;
extern struct artist *artists_root;
extern struct albumlist *albums_root;
extern struct playlist *playlist_root;
extern struct selection selection;


void
on_edit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

/* updates the progressbar during upload */
void feedback(int count, int total)
{
	GtkProgressBar *pbar;
	extern GtkWidget *uploadwindow;
	//printf("feedback %i/%i %i%%\n",count,total,100*count/total);
	if ( uploadwindow != NULL ) {
	  gdk_threads_enter();
	  pbar = (GtkProgressBar *)lookup_widget(uploadwindow,"progressbar1");
	  gtk_progress_bar_update(pbar,(gfloat)count/total);
	  gdk_threads_leave();
	}
}

/* the upload thread... takes the next song from the upload list (if any)
   and starts the actual upload procedure. adds the song to the internal 
   database structures afterwards */
void uploadwindow_thread() 
{
	struct uploadlist *uplist;
	extern pthread_mutex_t uploadlist_mutex;
	extern struct uploadlist *uploadlist;
	struct uploadlist *tmp,*current;
	extern GtkWidget *uploadwindow;
	GtkProgressBar *pbar;
	while ( 1 == 1 ) {
		/* FIXME : without sleep, crashes when closing uploadwindow */
		sleep(1);
		if (debug) {
			printf("starting while loop\n");
			printf("starting mutex\n");
		}
		pthread_mutex_lock(&uploadlist_mutex);
		uplist = uploadlist;
		if (debug) {
			while ( uplist != NULL ) {
				printf("uplist : %s\n",uplist->file);
				uplist = uplist->next;
			}
		}
		if ( uploadlist != NULL ) {
			GtkLabel *label = NULL;
			gchar text[100];
			if (debug) {printf("now uploading : %s\n",uploadlist->file);}
			current = uploadlist;
			uplist = uploadlist;
			uploadlist = uploadlist->next;
			/* FIXME : maybe do this afterwards
			   otherwise list in uploadwindow is different
			   after close/open */
			pthread_mutex_unlock(&uploadlist_mutex);
			//text = "now test";
			sprintf(text,"Now uploading: %s",current->song->title);
			if (debug) {printf("Now uploading: %s\n",current->song->title);}
			if ( uploadwindow != NULL ) {
			  gdk_threads_enter();
			  label = (GtkLabel *)lookup_widget(uploadwindow,"label29");
			  gtk_label_set_justify(label,GTK_JUSTIFY_LEFT);
			  //gtk_misc_set_alignment (GTK_MISC(uploadwindow), 0, 0.5);
			  gtk_misc_set_alignment ((GtkMisc*)uploadwindow, 0, 0.5);
			  gtk_widget_show(uploadwindow);
			  gtk_label_set_text(label,text);
			  gdk_flush();
			  gdk_threads_leave();
			}
			if (debug) {printf("before upload\n");}
			nomadJB_upload_file(current->file, current->song, feedback);
			if (debug) {printf("after upload\n");}
			gdk_threads_enter();
			printf("idx %i\n",(int)current->song->idx);
			add_song(current->song);
			show_genres(selection.genre);
			show_artists(selection.artist);
			show_albums(selection.album);
			show_songs();
			gdk_threads_leave();
			if ( uploadwindow != NULL ) {
			  gdk_threads_enter();
			  pbar = (GtkProgressBar *)lookup_widget(uploadwindow,"progressbar1");
			  gtk_progress_bar_update(pbar,0);
			  gtk_label_set_text(label,(gchar *)"Now uploading:");
			  gdk_threads_leave();
			}
			//free(uplist->file);
			if (debug) {printf("after free 1\n");}
			// need to do this properly
			//free(uplist->tags);
			if (debug) {printf("after free 2\n");}
			//free(uplist);
			free(current);
			if (debug) {printf("after free 3\n");}
		}
		else { 
			if (debug) {printf("empty list\n");}
			//this should fix the locks... maybe change program structure later...
			pthread_mutex_unlock(&uploadlist_mutex);
		}
		if (debug) {printf("before ending mutex\n");}
		// sometimes locks here !?
		if ( uploadwindow != NULL ) {
			GtkCList *clist;
			if (debug) {printf("before gdk_enter\n");}
			gdk_threads_enter();
			if (debug) {printf("after gdk_enter\n");}
			clist = (GtkCList *)lookup_widget(uploadwindow,"clist2");
			gtk_clist_freeze(clist);
			gtk_clist_clear(clist);
			if (debug) {printf("before mutex_lock\n");}
			// this is where it locks...
			pthread_mutex_lock(&uploadlist_mutex);
			if (debug) {printf("after mutex_lock\n");}
			tmp = uploadlist;
			/*while ( tmp != NULL ) {
			  SONG *song = tmp->song;
			  gchar *cells[5] = { song->title, "te", "tes", "test", "testi" };
			  gtk_clist_append((GtkCList *)clist, cells );
			  tmp = tmp->next;
			  }*/
			construct_clist(uploadlist, clist);
			pthread_mutex_unlock(&uploadlist_mutex);
			gtk_clist_thaw (clist);
			//printf("alloc %i\n",uploadwindow->allocation.x);
			//gtk_widget_draw_default (uploadwindow);
			//gtk_widget_draw_focus (clist);
			if (debug) {printf("ending mutex 1\n");}
			//pbar = lookup_widget(uploadwindow,"progressbar1");
			//gtk_progress_bar_update(pbar,0);
			gdk_flush();
			gdk_threads_leave();
		}
		if (debug) {
			printf("ending mutex 2\n");
			printf("ending mutex\n");
			printf("\n");
			printf("ending while loop\n");
		}
	}
	pthread_exit(0);
}


void construct_cells(gchar *cells[5], SONG *song)
{
	char *size;
	cells[0] = song->artist;
	cells[1] = song->album;
	cells[2] = song->title;
	// FIXME
	size = (char *)malloc(15);
	sprintf(size,"%i",song->size);
	if (debug) {printf("%s\n",size);}
	//sprintf(cells[3],"%i",song->size);
	cells[3] = size;
	if (debug) {printf("test %s\n",cells[3]);}
	cells[4] = "test";
	//cells = { song->artist, song->album, song->title, "test", "testi" };
	//return cells;
}

/* creates a clist with the songs to be uploaded in it */
void construct_clist(struct uploadlist *tmp, GtkCList *clist)
{
	while ( tmp != NULL ) {
		SONG *song = tmp->song;
		gchar *cells[5];
		if (debug) {printf("testing...\n");}
		construct_cells(cells, song);
		if (debug) {printf("test %s\n",cells[3]);}
		//gchar *cells[5] = { song->artist, song->album, song->title, "test", "testi" };
		gtk_clist_append(clist, cells );
		tmp = tmp->next;
	}
}

/* shows the upload window */
void show_uploadwindow                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	extern GtkWidget *uploadwindow;
	extern pthread_mutex_t uploadlist_mutex;
	extern struct uploadlist *uploadlist;
	struct uploadlist *tmp;
	GtkCList *clist;
  
	if (debug) {printf("showing uploadwindow\n");}
	uploadwindow = create_uploadwindow();
	clist = (GtkCList *)lookup_widget(uploadwindow,"clist2");
	gtk_clist_clear(clist);
	pthread_mutex_lock(&uploadlist_mutex);
	tmp = uploadlist;
	/*while ( tmp != NULL ) {
	  SONG *song = tmp->song;
	  gchar *cells[5] = { song->title, "te", "tes", "test", "testi" };
	  gtk_clist_append((GtkCList *)clist, cells );
	  tmp = tmp->next;
	  }*/
	construct_clist(uploadlist, clist);	
	pthread_mutex_unlock(&uploadlist_mutex);
	gtk_widget_show ((GtkWidget *)uploadwindow);
}

/* adds song to the uploadlist and checks if the upload thread exists. If not, 
   creates the thread */
void
add_file_to_uploadlist(char *filename, SONG *song)
{
	extern pthread_mutex_t uploadlist_mutex;
	extern struct uploadlist *uploadlist;
	extern GtkWidget *uploadwindow;
	static pthread_t tid = 0;
	struct uploadlist *newuplist;
	void *arg = NULL;

	if ( tid != 0 ) {
		if (debug) {printf("previous thread id %li - before lock\n", tid);}
		pthread_mutex_lock(&uploadlist_mutex);
		if (debug) {printf("after lock\n");}
		if ( uploadlist != NULL ) {
			newuplist = uploadlist;
			while ( newuplist->next != NULL ) newuplist = newuplist->next;
			newuplist->next = (struct uploadlist*)malloc(sizeof(struct uploadlist));
			newuplist = newuplist->next;
		}
		else { 
			newuplist = (struct uploadlist*)malloc(sizeof(struct uploadlist));
			uploadlist = newuplist;
		}
		newuplist->file = (char *)malloc(strlen(filename)+1);
		strcpy(newuplist->file, filename);
		newuplist->song = song;
		newuplist->next = NULL;
		
		newuplist = uploadlist;
		if (debug) {
			while ( newuplist != NULL ) {
				printf("** uplist : %s\n",newuplist->file);
				newuplist = newuplist->next;
			}
		}
		if ( uploadwindow != NULL ) {
		        GtkCList *clist = (GtkCList *)lookup_widget(uploadwindow,"clist2");
			gchar *cells[5]; // = { song->artist, song->album, song->title, "test", "testi" };
			construct_cells(cells, song);
			//song->title, "te", "tes", "test", "testi" };
			gtk_clist_append(clist, cells );
			gtk_widget_draw_default (uploadwindow);
		}

		pthread_mutex_unlock(&uploadlist_mutex);
		
	}
	else {
		newuplist = (struct uploadlist*)malloc(sizeof(struct uploadlist));
		newuplist->file = (char *)malloc(strlen(filename)+1);
		strcpy(newuplist->file, filename);
				//printf("filename = %s\n",newuplist->file);
		newuplist->song = song;
		newuplist->next = NULL;
		// maybe lock here ?
		uploadlist = newuplist;
		if ( pthread_create(&tid, NULL, (void *)uploadwindow_thread, arg) != 0 ) printf("create thread failed\n");
		else if (debug) { printf("create thread succeeded\n");}
		if (debug) {printf("try showing uploadwindow\n");}
		show_uploadwindow(NULL,NULL);
	}
}

/* called when ok button clicked in fileselection window for uploads...
   checks if file exists, what type it is , gets id3 info, and adds the 
   created SONG structure to the uploadlist */
void
on_ok_button1_clicked                  (GtkWidget       *filesel,
					gpointer         user_data)
{
	char *filename, *temp;
	SONG *song;
	struct stat *BUF;

	filesel = fileselection1;
	if (debug) {printf("starting on_ok_button1_clicked\n");}
	temp = gtk_file_selection_get_filename (GTK_FILE_SELECTION(filesel));
	if (debug) {printf("after getfilename\n");}
	filename = (char *)malloc(strlen(temp)+1);
	if (debug) {printf("after malloc\n");}
	strcpy(filename,temp);
	if (debug) {printf("before destroy\n");}
	gtk_widget_destroy(filesel);
	if (debug) {printf("after destroy\n");}
	g_print ("%s\n", filename);
	if (debug) {printf("filename = %s\n",filename);}

	BUF = malloc(sizeof(struct stat));
	if ( stat(filename,BUF) == 0 ) {
		if (debug) {
			printf("Mode : %x %x %x\n",BUF->st_mode, S_IFDIR, S_IFREG);
			printf("Mode : %x %x\n",BUF->st_mode & S_IFDIR,BUF->st_mode & S_IFREG);
		}
		if ( BUF->st_mode & S_IFDIR ) {
			if (debug) {printf("directory\n");}
		}
		else if ( BUF->st_mode & S_IFREG ) {
			char *text;
			
			text = strrchr(filename,'.');
			if ( text != NULL ) { printf("%s\n",text); }
			if ( text != NULL && strcmp(".mp3",text) == 0 ) {
				if (debug) {printf("it's an mp3 !\n");}
				song = id3song(filename);
				if (debug) {printf("returned from tags\n");}
				add_file_to_uploadlist(filename,song);
			}
			else if ( text != NULL && strcmp(".m3u",text) == 0 ) {
				if (debug) {printf("it's an m3u !\n");}
				
			}

		}
		else {  if (debug) {printf("no match\n");} }
	}
	else { printf("couldn't stat file\n"); }
	if (debug) {printf("ending on_ok_button1_clicked\n");}
}

/* called when upload button is clicked */
void
upload_file                            (GtkButton       *button,
                                        gpointer         user_data)
{
	fileselection1 = create_fileselection1();
	gtk_widget_show (fileselection1);
}

void
on_uploadwindow_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
	extern GtkWidget *uploadwindow;
	if (debug) {
		printf("test %i\n",(int)uploadwindow);
		printf("destroyed!\n");
	}
	uploadwindow = NULL;
	if (debug) {printf("test %i\n",(int)uploadwindow);}
	
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_new_file2_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_open2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_as2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_exit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cut2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties2_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences2_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	
}


void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void reset_selection()
{
	selection.genre = NULL;
	selection.artist = NULL;
	selection.album = NULL;
	selection.playlist = NULL;
}

void select_row_genres_callback (GtkCList *clist, gint row, gint column,
				 GdkEvent *event, gpointer user_data)
{
	struct genre *genre;
	//printf("in select\n");
	if ( row == 0 ) genre = NULL;
	else genre = (struct genre *)gtk_clist_get_row_data(clist,row);
	//printf("in select 2\n");
	//if ( genre ) printf ("--- genre %s\n",genre->name);
	//if ( selection.genre ) printf ("--- old genre %s\n",selection.genre->name);
	//printf("in select 3\n");
	if (genre != selection.genre) {
		//if ( genre ) printf ("--- new genre %s\n",genre->name);
		selection.genre = genre;
		selection.artist = NULL;
		selection.album = NULL;
		show_artists(NULL);
		show_albums(NULL);
		show_songs();
	}
	//printf ("--- %s\n",genre->name);
}

void select_row_artists_callback (GtkCList *clist, gint row, gint column,
				  GdkEvent *event, gpointer user_data)
{
	struct artist *artist;
	if ( row == 0 ) artist = NULL;
	else artist = (struct artist *)gtk_clist_get_row_data(clist,row);
	if (artist != selection.artist) {
		selection.artist = artist;
		selection.album = NULL;
		show_albums(NULL);
		show_songs();
	}
	//if (artist) printf ("--- %s\n",artist->name);
}

void select_row_albums_callback (GtkCList *clist, gint row, gint column,
				 GdkEvent *event, gpointer user_data)
{
	struct album *album;
	struct songlist *songs;
	if ( row == 0 ) album = NULL;
	else album = (struct album *)gtk_clist_get_row_data(clist,row);
	if ( row != 0 ) {
		printf("album %s\n",album->name);
		songs = album->songs;
		while (songs) {
			printf("  song %s\n",songs->song->title);
			songs = songs->next;
		}
	}
	if (album != selection.album) {
		selection.album = album;
		show_songs();
	}
	//if (album) printf ("--- %s\n",album->name);
}

void
select_row_playlist_callback           (GtkCList *clist, gint row, gint column,
                                        GdkEvent *event, gpointer user_data)
{
	struct playlist *playlist = (struct playlist *)gtk_clist_get_row_data(clist,row);
	if (playlist != selection.playlist) {
		selection.playlist = playlist;
		show_songs();
	}
}

void show_genres(struct genre *select)
{
	GtkCList *clist;
	struct genre *genre;
	gchar *list_all[1] = { "All" };
	int i,j=0;

	clist = (GtkCList *)lookup_widget(app2,"clist4");
	gtk_clist_clear(clist);
	genre = genres_root;
	gtk_clist_append(clist, list_all );
	gtk_clist_set_row_data(clist,0,NULL);
    
	i = 1;
	while ( genre != NULL ) {
		gchar *list[1] = { genre->name };
		if ( genre == select ) j = i;
		//printf("%s\n",genre->name);
		//printf("in while %s\n",artists->name);
		gtk_clist_append(clist, list );
		gtk_clist_set_row_data(clist,i,genre);
		genre = genre->next;
		i++;
	}
	gtk_clist_select_row(clist, j, 0);
	if ( select ) gtk_clist_moveto(clist,j,0,0.5,0.5);
}

int check_artist_selection(struct artist *artist)
{
	struct albumlist *albums;
	if ( ! selection.genre ) return 1;
	albums = artist->albums;
	while ( albums ) {
		struct songlist *songs = albums->album->songs;
		while ( songs ) {
			//printf("------------- %s\n",songs->song->genre);
			if (selection.genre) { 
				//printf("------------- %s\n",selection.genre->name);
				if ( strcmp(songs->song->genre,selection.genre->name) == 0 )
					return 1;
			}
			songs = songs->next;
		}
		albums = albums->next;
	}
	return 0;
}

void show_artists(struct artist *select)
{
	GtkCList *clist;
	struct artist *artist;
	gchar *list[1] = { "All" };
	int i,j=0;
	//GtkAdjustment *adjust;
	//GtkScrolledWindow *scroll;

	printf("show_artist\n");
	clist = (GtkCList *)lookup_widget(app2,"clist5");
	//if ( select ) {
	//	printf("get adjust\n");
	//	scroll = (GtkScrolledWindow *)lookup_widget(app2,"scrolledwindow5");
	//	adjust = gtk_clist_get_vadjustment(clist);
	//}
	gtk_clist_clear(clist);
	artist = artists_root;
	gtk_clist_append(clist, list );
	gtk_clist_set_row_data(clist,0,NULL);
	i = 1;
	while ( artist != NULL ) {
		gchar *list[1] = {artist->name};
		if ( check_artist_selection(artist) == 0 ) {
			//printf("no match\n");
			artist = artist->next;
			continue;
		}
		if ( artist == select ) j = i;
		//printf("%s\n",artist->name);
		gtk_clist_append(clist, list );
		gtk_clist_set_row_data(clist,i,artist);
		artist = artist->next;
		i++;
	}
	gtk_clist_select_row(clist, j, 0);
	if ( select ) {
		//printf("set adjust\n");
		//gtk_clist_set_vadjustment(clist, adjust);
		//gtk_widget_set_scroll_adjustments(clist,adjust,adjust);
		gtk_clist_moveto(clist,j,0,0.5,0.5);
	}
	//gtk_signal_connect(GTK_OBJECT(clist), "select_row",
	//GTK_SIGNAL_FUNC(select_row_artists_callback),NULL);
}

/* checks album against selection criteria */
int check_album_selection(struct albumlist *album)
{
	struct songlist *songs = album->album->songs;
	if ( ! selection.genre ) return 1;
	while ( songs ) {
		//printf("------------- %s\n",songs->song->genre);
		if (selection.genre) { 
			//printf("------------- %s\n",selection.genre->name);
			if ( strcmp(songs->song->genre,selection.genre->name) == 0 )
				return 1;
		}
		songs = songs->next;
	}
	return 0;
}

/* show albums, according to genre selection */
void show_albums(struct albumlist *select)
{
	GtkCList *clist;
	struct albumlist *album;
	gchar *list_all[1] = { "All" };
	int i,j=0;
	
	printf("show_albums\n");
	clist = (GtkCList *)lookup_widget(app2,"clist6");
	gtk_clist_clear(clist);
	if ( selection.artist ) { album = selection.artist->albums;
	printf("selection artist\n"); }
	else if ( selection.genre ) { 
		album = selection.genre->albums;
		printf("selection genre\n"); }
	else { 
		album = albums_root;
		printf("no selection\n"); }
	
	gtk_clist_append(clist, list_all );
	gtk_clist_set_row_data(clist,0,NULL);
	i = 1;
	while ( album != NULL ) {
		gchar *list[1] = { album->album->name };
		if ( check_album_selection(album) == 0 ) {
			album = album->next;
			continue;
		}
		if ( album->album == select ) j = i;
		//printf("%s\n",album->album->name);
		gtk_clist_append(clist, list );
		gtk_clist_set_row_data(clist,i,album->album);
		album = album->next;
		i++;
	}
	gtk_clist_select_row(clist, j, 0);
	if ( select ) gtk_clist_moveto(clist,j,0,0.5,0.5);
	//gtk_signal_connect(GTK_OBJECT(clist), "select_row",
	//GTK_SIGNAL_FUNC(select_row_albums_callback),NULL);
}

/* checks a song against selection criteria */
int check_song_selection(SONG *song)
{
	if ( selection.genre )
		if ( strcmp(selection.genre->name,song->genre) != 0 )
			return 0;
	if ( selection.artist )
		if ( strcmp(selection.artist->name,song->artist) != 0 )
			return 0;
	if ( selection.album )
		if ( strcmp(selection.album->name,song->album) != 0 )
			return 0;
	if ( selection.playlist ) {
		struct songlist *songs = selection.playlist->songs;
		while ( songs ) {
			if ( song == songs->song ) return 1;
			songs = songs->next;
		}
		return 0;
	}
	return 1;
}

/* shows songs according to selection criteria */
void show_songs()
{
	GtkCList *clist;
	struct songlist *songs = songs_root;
	int i = 0;

	clist = (GtkCList *)lookup_widget(app2,"clist3");
	gtk_clist_clear(clist);
	while ( songs != NULL ) {
		gchar *list[3] = { songs->song->title, songs->song->artist, songs->song->album };
		if ( check_song_selection(songs->song) == 0 ) {
			songs = songs->next;
			continue;
		}
		//list[3] = { songs->song->title, songs->song->artist, "test" };
		gtk_clist_append(clist, list );
		gtk_clist_set_row_data(clist,i,songs->song);
		//gtk_clist_set_row_data(clist,i,songs->song);
		i++;
		songs = songs->next;
	}
}

/* shows all playlists */
void show_playlists()
{
	GtkCList *clist;
	struct playlist *playlist;
	int i;

	clist = (GtkCList *)lookup_widget(app2,"clist7");
	gtk_clist_clear(clist);
	playlist = playlist_root;
	
	i=0;
	while ( playlist != NULL ) {
		gchar *album[1] = { playlist->name };
		gtk_clist_append(clist, album );
		gtk_clist_set_row_data(clist,i,playlist);
		playlist = playlist->next;
		i++;
	}
	gtk_clist_select_row(clist, 0, 0);
}

/* shows all songs */
void show_all ()
{
  printf("showall\n");
  selection.genre  = NULL;
  selection.artist = NULL;
  selection.album  = NULL;

  show_genres(NULL);
  
  show_artists(NULL);
  
  show_albums(NULL);
  
  show_songs();
  
}

/* switches to normal library view (genre/artist/album) */
void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *vpaned1;
	GtkWidget *hbox2;
	GtkWidget *scrolledwindow7;

	printf("button7 clicked\n");
	vpaned1 = lookup_widget(app2,"vpaned1");
	scrolledwindow7 = lookup_widget(app2,"scrolledwindow7");
	if ( scrolledwindow7 ) {
	  if ( scrolledwindow7->parent ) {
	    printf("scrolledwindow7 present... removing\n");
	    gtk_container_remove((GtkContainer *)vpaned1,scrolledwindow7);
	  }
	  else printf("scrolledwindow7 present but no parent found\n");
	}
	else printf("scrolledwindow7 not found\n");

	hbox2 = lookup_widget(app2,"hbox2");
	gtk_widget_show (hbox2);
	gtk_paned_pack1 (GTK_PANED (vpaned1), hbox2, FALSE, TRUE);
	reset_selection();
	show_genres(NULL);
	show_songs();
}

/* switches to playlist view */
void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *vpaned1;
	GtkWidget *scrolledwindow7;
	GtkWidget *clist7;
	GtkWidget *label42;
	GtkWidget *hbox2;
	
	printf("button8 clicked\n");
	vpaned1 = lookup_widget(app2,"vpaned1");
	hbox2 = lookup_widget(app2,"hbox2");
	if ( hbox2 ) 
	  if ( hbox2->parent ) 
	    gtk_container_remove((GtkContainer *)vpaned1,hbox2);
	
	scrolledwindow7 = lookup_widget(app2,"scrolledwindow7");
	if ( scrolledwindow7 ) {
	  gtk_widget_show (scrolledwindow7);
	  gtk_paned_pack1 (GTK_PANED (vpaned1), scrolledwindow7, FALSE, TRUE);
	}
	else {
	  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
	  gtk_widget_ref (scrolledwindow7);
	  gtk_object_set_data_full (GTK_OBJECT (app2), "scrolledwindow7", scrolledwindow7,
				    (GtkDestroyNotify) gtk_widget_unref);
	  gtk_widget_show (scrolledwindow7);
	  //gtk_container_add (GTK_CONTAINER (app2), scrolledwindow7);
	  gtk_paned_pack1 (GTK_PANED (vpaned1), scrolledwindow7, FALSE, TRUE);
	  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	  
	  clist7 = gtk_clist_new (1);
	  gtk_widget_ref (clist7);
	  gtk_object_set_data_full (GTK_OBJECT (app2), "clist7", clist7,
				    (GtkDestroyNotify) gtk_widget_unref);
	  gtk_widget_show (clist7);
	  gtk_container_add (GTK_CONTAINER (scrolledwindow7), clist7);
	  gtk_clist_set_column_width (GTK_CLIST (clist7), 0, 80);
	  gtk_clist_column_titles_show (GTK_CLIST (clist7));
	  
	  label42 = gtk_label_new (_("Playlist"));
	  gtk_widget_ref (label42);
	  gtk_object_set_data_full (GTK_OBJECT (app2), "label42", label42,
				    (GtkDestroyNotify) gtk_widget_unref);
	  gtk_widget_show (label42);
	  gtk_clist_set_column_widget (GTK_CLIST (clist7), 0, label42);
	  
	  gtk_signal_connect (GTK_OBJECT (clist7), "select_row",
			      GTK_SIGNAL_FUNC (select_row_playlist_callback),
			      NULL);
	}
	reset_selection();
	show_playlists();
	show_songs();
}

/* checks if artist/genre still has albums listed... if not, remove */
int check_artists_after_delete(struct artist **root)
{
	struct artist *artist = *root;
	struct artist *previous = NULL;

	while (artist) {
		if (artist->albums == NULL) {
			printf("empty artist/genre %s\n",artist->name);
			printf("empty album\n");
			if (previous)
				previous->next = artist->next;
			else if (artist->next)
				*root = artist->next;
			else
				*root = NULL;
			free(artist);
			return 1;
		}
		previous = artist;
		artist = artist->next;
	}
	return 0;
}

/* checks that the specified artist/genre is present in songlist's artists...
   necessary for multi-artist(genre) albums */
int check_cross_section(struct songlist *songs,int type, struct artist *artist)
{
	if ( type == 0 ) return 0;
	while (songs) {
		if ( (type == 1) && (strcmp(songs->song->artist,artist->name) == 0) )
			return 0;
		if ( (type == 2) && (strcmp(songs->song->genre,artist->name) == 0) )
			return 0;
		songs = songs->next;
	}
	printf("did not find artist or genre in songlist\n");
	return 1;
}

/* checks if an album still has songs, if not deletes it */
struct album *check_albums_after_delete(struct albumlist **root, int type, struct artist *artist)
{
	struct albumlist *albums = *root;
	struct albumlist *previous = NULL;

	//printf("check albums\n");
	while (albums) {
		if ( (albums->album->songs == NULL) ||
		     check_cross_section(albums->album->songs,type,artist) ) {
			struct album *ret = albums->album;
			//printf("empty album\n");
			if (previous)
				previous->next = albums->next;
			else if (albums->next)
				*root = albums->next;
			else
				*root = NULL;
			free(albums);
			return ret;
		}
		previous = albums;
		albums = albums->next;
	}
	return NULL;
}

/* removes a song from the specified songlist, and frees the songlist entry */
int remove_from_songlist(SONG *song,struct songlist **root)
{
	struct songlist *songs = *root;
	struct songlist *previous = NULL;
	
	while (songs) {
		if ( songs->song == song ) {
			if (previous)
				previous->next = songs->next;
			else if (songs->next)
				*root = songs->next;
			else
				*root = NULL;
			free(songs);
			return 1;
		}
		previous = songs;
		songs = songs->next;
	}
	return 0;
}

/* removes a list of songs from the device */
void remove_songs(struct songlist *songs)
{
	struct albumlist *albums = albums_root;

	while (songs) {
		struct songlist *previous = songs;
		struct artist *artists = artists_root;
		struct genre *genres = genres_root;
		struct album *ret;
		int result;
		
		printf("removing song %s %i\n",songs->song->title,(int)songs->song->idx);
		nomadJB_delete_song(songs->song);
		
		remove_from_songlist(songs->song,&songs_root);
		albums = albums_root;
		while (albums) {
			/*struct songlist *songs2 = albums->album->songs;
			printf("album %s\n",albums->album->name);
			while (songs2) {
				printf("songs %s\n",songs2->song->title);
				songs2 = songs2->next;
				}*/
			if (remove_from_songlist(songs->song,&albums->album->songs))
				break;
			albums = albums->next;
		}
		free(songs->song);
		//printf("before show_song\n");
		show_songs();
		//printf("after show_song\n");
		
		/* FIXME : multi artist albums ?? */
		ret = check_albums_after_delete(&albums_root,0,NULL);
		while (artists) {
			check_albums_after_delete(&artists->albums,1,artists);
			artists = artists->next;
		}
		while (genres) {
			check_albums_after_delete(&genres->albums,2,(struct artist*)genres);
			genres = genres->next;
		}
		if (ret) {
			show_albums(NULL);
			free(ret);
		}
		
		result = check_artists_after_delete(&artists_root);
		if (result) show_artists(NULL);
		result = check_artists_after_delete((struct artist**)&genres_root);
		if (result) show_genres(NULL);
		
		songs = songs->next;
		free(previous);
	}
}

/* removes the selected song */
void
on_delete_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkCList *clist = (GtkCList *)lookup_widget(app2,"clist3");
	SONG *song;
	GList *row;
	struct songlist *removelist=NULL,*temp;
	struct songlist **p_temp = &removelist;

	row = GTK_CLIST(clist)->selection;

	while( row ) {
		printf( "row %d is selected\n", (int)row->data );
		song = (SONG *)gtk_clist_get_row_data(clist,(int)row->data);
		temp = (struct songlist *)malloc(sizeof(struct songlist));
		temp->song = song;
		temp->next = NULL;
		*p_temp = temp;
		//remove_song(song);
		printf("song %s\n",song->title);
		row = row->next;
	}
	remove_songs(removelist);
}

