/*  ----------------------------------------------------------------------

    Copyright (C) 2001  Tom Vandenhove  (tom.vandenhove@ubizen.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    ---------------------------------------------------------------------- */


#include <gnome.h>
#include "nomadJB_data.h"

struct selection {
	struct genre *genre;
	struct artist *artist;
	struct album *album;
	struct playlist *playlist;
};


void
on_edit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_help2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ok_button1_clicked                  (GtkWidget       *filesel,
                                        gpointer         user_data);

void
on_uploadlist_destroy                  (GtkObject       *object,
                                        gpointer         user_data);

void
on_uploadwindow_destroy                (GtkObject       *object,
                                        gpointer         user_data);

void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_new_file2_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_as2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_exit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_properties2_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_preferences2_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
select_row_genres_callback             (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
select_row_artists_callback            (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
select_row_albums_callback             (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
select_row_playlist_callback           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
show_uploadwindow                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void feedback(int count, int total);
void uploadwindow_thread(void);
void construct_cells(gchar *cells[5], SONG *song);
void construct_clist(struct uploadlist *tmp, GtkCList *clist);
void add_file_to_uploadlist(char *filename, SONG *song);
void reset_selection(void);
void show_genres(struct genre*);
int check_artist_selection(struct artist *artist);
void show_artists(struct artist *select);
int check_album_selection(struct albumlist *album);
void show_albums(struct albumlist *);
int check_song_selection(SONG *song);
void show_songs(void);
void show_playlists(void);
void show_all (void);

void
upload_file                            (GtkButton       *button,
                                        gpointer         user_data);

void
on_delete_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);
