/*  ----------------------------------------------------------------------

    Copyright (C) 2000  Gabriel Gomiz  (gomita@bblanca.com.ar)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    ---------------------------------------------------------------------- */

/*
 * nomad_ctl -- Command tables
 */

#include "nomad_ctl.h"

int     quit(),help(),dev_open(),dev_close(),model(),owner();
int     status(),memory(),count(),list(),version(),format();
int     download(),read_presets(),presets(),dev_clock(),upload();

char	quithelp[]     = "exit nomad_ctl";
char    helphelp[]     = "get help on commands";
char    openhelp[]     = "open nomad device";
char    closehelp[]    = "close nomad device";
char    modelhelp[]    = "get device model information";
char    ownerhelp[]    = "get/set owner information \n\
	owner get: shows current device owner \n\
	owner set name: sets owner to the string name";
char    stathelp[]     = "show current status";
char    memhelp[]      = "show flash memory capacity status";
char    counthelp[]    = "number of files in flash memory";
char    listhelp[]     = "list flash memory contents";
char    versionhelp[]  = "display version information";
char    formathelp[]   = "formats flash memory";
char    presetshelp[]  = "get/set radio presets \n\
	presets read: loads all presets from device to local \n\
	presets write: save all presets form local to device \n\
	presets set n f1 f2: set preset #n to f1.f2 \n\
		example: presets set 1 91 50";
char    clockhelp[]    = "get/set device clock \n\
	clock get: shows device clock \n\
	clock set: sets device clock to local clock";
char    downloadhelp[] = "puts a mp3 file on flash memory";
char    uploadhelp[] = "uploads an mp3 file to NJB disk";

struct cmd cmdtab[] = {
	{ "quit",       quithelp,       quit         },
	{ "bye",        quithelp,       quit         },
	{ "exit",       quithelp,       quit         },
	{ "help",       helphelp,       help         },
	{ "status",     stathelp,       status       },
	{ "open",       openhelp,       dev_open     },
	{ "close",      closehelp,      dev_close    },
	{ "model",      modelhelp,      model        },
	{ "owner",      ownerhelp,      owner        },
	{ "memory",     memhelp,        memory       },
	{ "count",      counthelp,      count        },
	{ "list",       listhelp,       list         },
	{ "version",    versionhelp,    version      },
	//	{ "format",     formathelp,     format       },
	//	{ "presets",    presetshelp,    presets      },
	{ "clock",      clockhelp,      dev_clock,   },
	//	{ "download",   downloadhelp,   download     },
	{ "upload",   uploadhelp,   upload     },
	{ 0 },
};

int	NCMDS = sizeof (cmdtab) / sizeof (cmdtab[0]);
