/*  ----------------------------------------------------------------------

    Copyright (C) 2001  Tom Vandenhove  (tom.vandenhove@ubizen.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    ---------------------------------------------------------------------- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <pthread.h>

#include "interface.h"
#include "support.h"
#include "nomadJB_data.h"
#include "data.h"
#include "callbacks.h"
#include <glib.h>
#include <pthread.h>
#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

GtkWidget *app1,*app2, *uploadwindow;
struct songlist *songs_root;
struct albumlist *albums_root;
struct artist *artists_root;
struct genre *genres_root;
struct playlist *playlist_root;
struct uploadlist *uploadlist = NULL;
struct selection selection;
struct test {
	struct artist *artists;
	GtkWidget *item;
};
pthread_mutex_t uploadlist_mutex;
gint clist_signal = -1;
int debug = 0;

int
main (int argc, char *argv[])
{
	g_thread_init(NULL);
	
#ifdef ENABLE_NLS
	bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain (PACKAGE);
#endif
	
	gnome_init ("toeareg", VERSION, argc, argv);
	
	uploadwindow = NULL;
	
	app2 = create_app2();
	gtk_signal_connect (GTK_OBJECT(app2), "delete_event",
			    GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	//show_all();
	
	gtk_widget_show (app2);
	
	pthread_mutex_init(&uploadlist_mutex, NULL);
	
	if (nomadJB_open() != 0) {
		printf("Error: Nomad Jukebox couldn't be opened!\n");
		return -1;
	} else { if (debug) {printf("Success: Nomad Jukebox opened!\n");} }
	if (nomadJB_lock() != 0) {
		printf("Error: Nomad Jukebox couldn't be locked!\n");
		return -1;
	}
	
	if (debug) {printf("Nomad Jukebox succesfully opened.\n");}

	restore_lists();
	create_indexes(songs_root, &albums_root, &artists_root, &genres_root);
	if (debug) {printf("created albums %i %i\n",&albums_root,albums_root);}
	show_all();
	
	gdk_threads_enter();
	gtk_main ();
	gdk_threads_leave();

	save_lists();

	if (nomadJB_close() != 0) {
		printf("Error: Nomad Jukebox couldn't be closed!\n");
		return -1;
	}
	printf("Nomad Jukebox succesfully closed.\n");
	
	return 0;
}

